package at.ac.tuwien.sepm.assignment.individual.service;

import at.ac.tuwien.sepm.assignment.individual.entity.Owner;
import at.ac.tuwien.sepm.assignment.individual.exception.NotFoundException;
import at.ac.tuwien.sepm.assignment.individual.util.ValidationException;
import org.springframework.dao.DataAccessException;

import java.io.IOException;

public interface OwnerService {


    /**
     * @param id of the owner to find.
     * @return the owner with the specified id.
     * @throws RuntimeException  will be thrown if something goes wrong during data processing.
     * @throws NotFoundException will be thrown if the owner could not be found in the system.
     */
    Owner findOneById(Long id);

    /**
     * @param owner to create
     * @return the new owner
     * @throws ValidationException will be thrown if something goes wrong during verification.
     * @throws DataAccessException will be thrown if the owner could not be saved in the database.
     */
    Owner addOwner(Owner owner) throws ValidationException, DataAccessException;

    /**
     * @param owner that specifies the new owner values alongside with the id of the owner to update
     * @return the updated owner
     * @throws ValidationException will be thrown if something goes wrong during verification.
     * @throws DataAccessException will be thrown if the owner could not be saved in the database.
     */
    Owner updateOwner(Owner owner) throws ValidationException, DataAccessException;
}
